"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Machine(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "DATE",
        "FLOWCELL",
        "MACHINE",
        "RUN",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.Machine": reports_3_0_0.Machine,
        }

    __slots__ = [
        "DATE",
        "FLOWCELL",
        "MACHINE",
        "RUN",
    ]

    def __init__(
        self,
        DATE,
        FLOWCELL,
        MACHINE,
        RUN,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.Machine model.

        :param DATE:
        :type DATE: double
        :param FLOWCELL:
        :type FLOWCELL: str
        :param MACHINE:
        :type MACHINE: str
        :param RUN:
        :type RUN: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
